<?php // draw_data_table.php: chok(tue 9 jul 2002)


function draw_data_table( $fields, &$data, $start_row=0, $rows_per_page=0,
	$sort_field_varname='', $sort_order_varname='', $delete_buttons=0 )
// draw a HTML table decorated and full of data
// use &$data as direct reference to avoid data duplication

// set $sort_buttons=1 to print the sort buttons
// if $delete_buttons==1, assume last field is LongIP and don't show it

{
	$fields_count = sizeof($fields);
	if($delete_buttons) $fields_count--;
	if($fields_count<=0) return 0; // life sux

	$rows_count = sizeof($data);

	global $PHP_SELF; // filename of current PHP file
	global $$sort_field_varname, $$sort_order_varname;
	global $img_number;

	$sort_buttons = strlen($sort_field_varname);
















  //
  //  print <table> tag and first row
  //

  $style = 'background="images/xp_bar.gif"
		style="border-bottom:solid 2px #777777;"';

  print('<table width=100% border=0 cellspacing=0 cellpadding=4
		style="border:solid 1px #1111aa;"><tr>' );

	// first column serves to take up space
	print("<td $style width=15 nowrap>&nbsp;</td>");

	// if $delete_buttons is set, then print delete buttons column
	if($delete_buttons)
		print("<td $style>&nbsp;</td>");

  // always add the index numbering automatically
  print("
		<td $style align=center valign=center>
			<font face=Arial color=#ffffff><b>No</b></font>
		</td>");

  // print each header item <th>...</th>
  foreach($fields as $fld):

  	if(strcmp($fld,'LongIP')==0) continue;

  	// use human readable field names
  	switch($f=$fld):
  	case('PercentActive'): $f='% Active'; break;
  	case('DateInserted'): $f='Date Inserted'; break;
  	case('LastActive'): $f='Last Active'; break;
  	case('LastModified'): $f='Last Modified'; break;
  	case('DaysOffline'): $f='Days Offline'; break;
  	endswitch;

		// how to display the field name
		$not_blank_field = 0;	// field may be blank (no name)
		if( strlen($f) ):
			$not_blank_field = 1;
			$print_field = "<font face=Arial color=#ffffff><b>$f</b></font>";
		else:
			$print_field = '';
		endif;

		if($sort_buttons):
    	// highlight the sort button if nec
    	$img_asc = 'sortasc';
    	$img_desc = 'sortdesc';
			$new_img_asc = 'sortasc_lite';
			$new_img_desc = 'sortdesc_lite';
    	if( strcmp($$sort_field_varname,$fld)==0 ):
    		if( strcmp($$sort_order_varname,'desc') ):
    			$img_asc = 'sortasc_lite';
					$new_img_asc = 'sortasc';
    		else:
    			$img_desc = 'sortdesc_lite';
					$new_img_desc = 'sortdesc';
				endif;
    	endif;

			$img_number ++; $img = "img$img_number";
		endif;

  	?>
  	<td <?=$style;?> valign=center align=center>

			<?php
			if($sort_buttons && $not_blank_field):
			?>

  		<table border=0 align=center cellpadding=0 cellspacing=0>
  		<tr>
  			<td valign=center align=center><?=$print_field;?>&nbsp;</td>
  				<td>
  				<table border=0 align=center valign=center cellpadding=0 cellspacing=0>
  				<tr>
  					<td align=center><?=make_href(
							"$PHP_SELF?submit=1&$sort_field_varname=" .
								str_replace(' ','%20',$fld) . "&$sort_order_varname=desc",
							"<img name=desc$img src=\"images/$img_desc.gif\"
								border=0>",
  						"window.status='Sort by $f in descending order';
								sortbutton_roll('desc$img', img_$new_img_desc);
								return true;",
  						"window.status='';
								sortbutton_roll('desc$img', img_$img_desc);
								return true;");
						?></td>
  				</tr>
  				<tr>
  					<td align=center><?=make_href(
							"$PHP_SELF?submit=1&$sort_field_varname=" .
								str_replace(' ','%20',$fld) . "&$sort_order_varname=asc",
							"<img name=asc$img src=\"images/$img_asc.gif\"
								border=0>",
  						"window.status='Sort by $f in ascending order';
								sortbutton_roll('asc$img', img_$new_img_asc);
								return true;",
  						"window.status='';
								sortbutton_roll('asc$img', img_$img_asc);
								return true;");
						?></td>
  				</tr>
  				</table>
  			</td>
  		</tr>
  		</table>

			<?php
			else:

				print($print_field);

			endif;
			?>

  	</td>
  	<?php
  endforeach;

	// last column serves to take up space
	print("<td $style width=15 nowrap>&nbsp;</td>");

  print('</tr>');









	//
	// print all data rows
	//

	$style_1 = 'align=center valign=center style="border-bottom:solid 1px #cccccc;"';
	$style = 'align=center valign=center style="border-bottom:solid 1px #cccccc;
		border-left:solid 1px #cccccc;"';

  if( $rows_count == 0 ):
  	print("<tr><td style=\"border-bottom:solid 1px #cccccc;
			border-right:solid 1px #cccccc; border-top:solid 1px #444444;
			border-left:solid 1px #444444;\"
			height=35 align=center colspan=" . ($fields_count+3) .
  		" bgcolor=#fafafa><font size=1 color=#ddaaaa><b>
			(No Data to Display)</b></font></td></tr>");
  else:
  	// get colspan for DNS cmp data within the IP table
		$colspan = $fields_count;
		$show_IP = in_array('IP', $fields);
		$show_Hostname = in_array('Hostname', $fields);
		if( $show_IP ) $colspan--;
		if( $show_Hostname ) $colspan--;

		// set $longIpFieldNum for $delete_buttons if necessary
		if($delete_buttons)
			$longIpFieldNum = $fields_count; // one past last field


		// make sure $start_row and $rows_per_page are valid
		if($rows_per_page<1 || $rows_per_page>$rows_count)
			$rows_per_page = $rows_count;

		if($start_row<1)
			$start_row = 1;
		if($start_row>$rows_count)
			$start_row = $rows_count - $rows_per_page + 1;

		// find the ending row
		$end_row = $start_row + $rows_per_page - 1;
		if($end_row > $rows_count) $end_row = $rows_count;

		// cycle thru only the rows in the included range
  	for( $i=$start_row; $i<=$end_row; $i++ ):

  		$row = $data[$i-1];

			// check whether this row is a row of DNS data or not
			$is_dns_row = strlen($row['ip']);

			// determine the background color
  			$bgcolor = ($i%3) ? '#ffffff' : '#eeeeee';
  		print( "<tr align=center bgcolor=$bgcolor>" );

			// first column serves to take up space
			print("<td $style_1>&nbsp;</td>");

  		// print delete checkboxes if necessary
  		if($delete_buttons):
  			$long_ip = $row[ $longIpFieldNum ];
  			print("<td $style_1><input name=\"ip[]\"
					type=checkbox value=\"$long_ip\"></td>");
  		endif;

  		// index numbering
  		print("<td $style_1>$i.</td>");

  		// print out data
			if( $is_dns_row ):
				// 'IP' must be field 0
				if( $show_IP ):
					print("<td $style><font color=#5555dd>" .
						$row['ip'] . "</font></td>");
				endif;

				// 'Hostname' must be field 1
				if( $show_Hostname ):
					print("<td $style>" . $row['hostname'] . "</td>");
				endif;

				// the rest of the fields
				if( $colspan>0 ):
					print("<td colspan=$colspan $style><font color=#5555dd>" .
						$row['disagreement'] . "</font></td>");
				endif;
			else:
  				// print all other fields
  				for( $j=0; $j<$fields_count; $j++ ):
  					print("<td $style>");
  					print(strlen($row[$j])? $row[$j] : '<font color=#bb8888>Nil</font>');
  					print('</td>');
  				endfor;
  		endif;

			// last column serves to take up space
			print("<td $style_1>&nbsp;</td>");

  		print('</tr>');

  	endfor;
  endif;







	//
	// print table footer
	//

	print('</table>');





	return 1;	// success
}

?>


<script>

var img_sortdesc = new Image();
	img_sortdesc.src = "images/sortdesc.gif";
var img_sortasc = new Image();
	img_sortasc.src = "images/sortasc.gif";
var img_sortdesc_lite = new Image();
	img_sortdesc_lite.src = "images/sortdesc_lite.gif";
var img_sortasc_lite = new Image();
	img_sortasc_lite.src = "images/sortasc_lite.gif";


function sortbutton_roll( img_name, new_img )
{
	eval('document.images.' + img_name + '.src = new_img.src');
}

</script>
